hdu 2795 Billboard (巧妙单点更新的线段树)

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/lvlinfeng970/article/details/80290661

Billboard

Time Limit: 20000/8000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 8962    Accepted Submission(s): 3997


Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that's why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.
 


 

Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.
 


 

Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can't be put on the billboard, output "-1" for this announcement.
 


 

Sample Input
 
  
3 5 5 2 4 3 3 3
 
Sample Output
 
  
1 2 1 3 -1
 


 

Author
hhanger@zju
 


 

Source


题目大意:

给一块h*w大小的白板,有n个公告每个公告的大小为1*wi,公告从上往下贴,如果本行不够位置就往下一行贴。求每个公告在第几行,如果贴不上就输出-1.

解题思路:

我们可以知道,在贴每次公告的时候,都要知道前面行的剩余宽度能否贴下这一条公告,如果暴力查询前面行的话复杂度为O(n^2) (n=20w肯定超时(tips:一共20w条公告,白板是矩形,所以如果白板的高度高过20w的话直接取20w即可。因为前面放不下后面也肯定放不下,宽度固定。))。所以想到用线段树维护前面的最大长度,巧妙地利用了线段树更新时的深搜特性,找到了最前面的一行并且更新,把查询更新从O(n)优化到了O(logn)。这道题如果直接背下线段树模板不加以理解应该是很难做出来的,平常在训练的时候要注重对数据结构的理解。

AC代码:

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Main{
    static Scanner input = new Scanner(System.in);
    static PrintWriter out = new PrintWriter(System.out);
    static int[] tree = new int[200000<<2|1];
    static int w;
    public static void main(String[] args){
        while(input.hasNext()){
        Arrays.fill(tree,0);
        int h = input.nextInt();
        w = input.nextInt();
        int n = input.nextInt();
        if(h>200000)h=200000;
        BuildTree(1,h,1);
        for(int i=0;i<n;i++){
            int a = input.nextInt();
            update(1,h,1,a);
        }
        out.flush();
        }
    }
    static void BuildTree(int l,int r,int root){
        if(l==r){
            tree[root] = w;
            return;
        }
        int m = (l+r)>>1;
        BuildTree(l,m,root<<1);
        BuildTree(m+1,r,root<<1|1);
        PushUp(root);
    }
    static void PushUp(int root){
        tree[root] = Math.max(tree[root<<1],tree[root<<1|1]);
    }
    static void update(int l,int r,int root,int value){
        if(l==r){
            tree[root] -= value;
            out.println(l);
            //PushUp(root);
            return;
        }
        int m = (l+r)>>1;
        if(tree[root<<1]>=value){
            update(l,m,root<<1,value);
            PushUp(root);
        }else if(tree[root<<1|1]>=value){
            update(m+1,r,root<<1|1,value);
            PushUp(root);
        }else{
            out.println(-1);
        }
    }
}

猜你喜欢

转载自blog.csdn.net/lvlinfeng970/article/details/80290661
今日推荐